package org.ow2.jonas.ws.axis2.jaxws.description.impl;


import javax.xml.namespace.QName;
import javax.xml.ws.handler.PortInfo;

import org.apache.axis2.jaxws.ExceptionFactory;
import org.apache.axis2.jaxws.i18n.Messages;

public class PortInfoImpl implements PortInfo {
    private QName serviceName = null;
    private QName portName = null;
    private String bindingId = null;

    /**
     * @param serviceName
     * @param portName
     * @param bindingId
     */
    PortInfoImpl(final QName serviceName, final QName portName, final String bindingId) {
        super();
        if (serviceName == null) {
            throw ExceptionFactory
                    .makeWebServiceException(Messages.getMessage("portInfoErr0", "<null>"));
        }
        if (portName == null) {
            throw ExceptionFactory
                    .makeWebServiceException(Messages.getMessage("portInfoErr1", "<null>"));
        }
        if (bindingId == null) {
            throw ExceptionFactory
                    .makeWebServiceException(Messages.getMessage("portInfoErr2", "<null>"));
        }
        this.serviceName = serviceName;
        this.portName = portName;
        this.bindingId = bindingId;
    }

    public QName getServiceName() {
        return serviceName;
    }

    public QName getPortName() {
        return portName;
    }

    public String getBindingID() {
        return bindingId;
    }
}
