# ---------------------------------------------------------------------------
# JOnAS: Java(TM) Open Application Server
# Copyright (C) 2005 Bull S.A.
# Contact: jonas-team@ow2.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): France Telecom
# Contributor(s): Guillaume Sauthier
#
# ---------------------------------------------------------------------------
# $Id$
# ---------------------------------------------------------------------------

# Product Constants
# -----------------------------
%define NAME JOnAS
%define PKG jonas
%define ComProd "Java Open Application Server"
%define Description "Java Open Application Server"

%define USER jonas
%define GROUP jonas

# Product Versionning
# -----------------------------
%define VERSION 5.0-M1
%define VERS v50m1
%define TAG JONAS_5_0_M1
%define RPM_VERSION 1.ow

# Web Container + Versionning
# -----------------------------
%define WEB_CONTAINER tomcat6.0.13

# Extensions Scripts names
# -----------------------------
%define INIT_D jonas.init.d
%define FUNCTIONS functions.sh

# Directories
# -----------------------------
%define JONAS_DIR        /opt/%{PKG}
%define JONAS_ROOT       %{JONAS_DIR}/%{TAG}
%define INIT_D_DIR       /etc/init.d
#FIXME uncomment if we use logrotate
#%define LOG_ROTATE_DIR   /etc/logrotate.d

#FIXME May be removed ?
# Note that this logger is not in the right location in the unintall step
%define LOG        /tmp/install_%{PKG}.log

# -----------------------------
# Package Description
# -----------------------------
Summary: %{Description}" "%{VERSION}
Name: %{PKG}
Version: %{VERSION}
Release: %{RPM_VERSION}
Copyright: LGPL
Group: Applications/Productivity
Source0: %{PKG}%{VERSION}-%{WEB_CONTAINER}.tgz
Source1: %{INIT_D}

BuildRoot: %{_tmpdir}/%{PKG}-buildroot
BuildArch: noarch

############################################################################
%description
The jonas package contains OW2's J2EE implementation (JOnAS).
Install this package if you wish to run a Java enterprise
web application server.  It includes its own copy of Apache
Tomcat and web-based administration interfaces.
############################################################################

%prep
# **************************************************************************
#                                                                     %%prep
# **************************************************************************
%setup -q -n %{TAG}

%install
# **************************************************************************
#                                                                  %%install
# **************************************************************************
if [ -d %{buildroot}/%{JONAS_DIR} ]; then
	rm -rf %{buildroot}/*
fi
mkdir -p %{buildroot}/%{JONAS_DIR}
mv %{_builddir}/%{TAG} %{buildroot}/%{JONAS_DIR}

#mkdir -p %{buildroot}/%{RepRotate}
mkdir -p %{buildroot}/%{INIT_D_DIR}

# Move and rename jonas.init.d in /etc/init.d/jonas
# Replace @JONAS_ROOT@ with the right value
sed "s#@JONAS_ROOT@#%{JONAS_ROOT}#g" %{_sourcedir}/%{INIT_D} > %{buildroot}/%{INIT_D_DIR}/%{PKG}

# Move and rename functions.sh in $JONAS_ROOT/bin/unix
cp %{_sourcedir}/%{FUNCTIONS} %{buildroot}/%{JONAS_ROOT}/bin/unix/functions

# Move env.sh in $JONAS_ROOT
# Replace @JONAS_ROOT@ with the right value
sed "s#@JONAS_ROOT@#%{JONAS_ROOT}#g" %{buildroot}/%{JONAS_ROOT}/conf/env.sh.include > %{buildroot}/%{JONAS_ROOT}/conf/env.sh.tmp
rm -f %{buildroot}/%{JONAS_ROOT}/conf/env.sh.include
mv %{buildroot}/%{JONAS_ROOT}/conf/env.sh.tmp %{buildroot}/%{JONAS_ROOT}/conf/env.sh.include

# TODO Maybe logrotate can be pushed inside the generic package
#mv %{RepTrav}/%{Prod}.logrotate.d %{buildroot}/%{RepRotate}/%{Prod}

# Move uneeded files from autoload
mv %{buildroot}/%{JONAS_ROOT}/apps/autoload/earsample.ear \
   %{buildroot}/%{JONAS_ROOT}/apps
mv %{buildroot}/%{JONAS_ROOT}/webapps/autoload/jonas-doc-en \
   %{buildroot}/%{JONAS_ROOT}/webapps
mv %{buildroot}/%{JONAS_ROOT}/webapps/autoload/jonas-emb-javadoc.war \
   %{buildroot}/%{JONAS_ROOT}/webapps
mv %{buildroot}/%{JONAS_ROOT}/webapps/autoload/tomcat-docs.war \
   %{buildroot}/%{JONAS_ROOT}/webapps
# ?? RA JORAM
# mv %{buildroot}/%{JONAS_ROOT}/rars/autoload/joram_for_jonas_ra.rar \
#    %{buildroot}/%{JONAS_ROOT}/rars


%files
# **************************************************************************
#                                                                    %%files
# **************************************************************************

%defattr(775,%{USER},%{GROUP})

%{JONAS_ROOT}/.classpath
%{JONAS_ROOT}/.package
%{JONAS_ROOT}/.project
%{JONAS_ROOT}/VERSIONS
%{JONAS_ROOT}/build.xml
%{JONAS_ROOT}/build-jb.xml
%{JONAS_ROOT}/build-jb.properties
%{JONAS_ROOT}/install.html
%{JONAS_ROOT}/LicenceAgreement.txt
%{JONAS_ROOT}/ReleaseNotes.txt
#FIXME Comment when package gets certified
%{JONAS_ROOT}/README.J2EE
#FIXME Uncomment when package gets certified
#%{JONAS_ROOT}/index.html
%{JONAS_ROOT}/conf/env.sh.include
%{JONAS_ROOT}/conf/env.start.sh.include

%{JONAS_ROOT}/demoserver
%{JONAS_ROOT}/examples
%{JONAS_ROOT}/bin
%{JONAS_ROOT}/lib
%{JONAS_ROOT}/logs
%{JONAS_ROOT}/templates
%{JONAS_ROOT}/xml

%config(noreplace) %{JONAS_ROOT}/apps
%config(noreplace) %{JONAS_ROOT}/conf
%config(noreplace) %{JONAS_ROOT}/ejbjars
%config(noreplace) %{JONAS_ROOT}/rars
%config(noreplace) %{JONAS_ROOT}/webapps
%config(noreplace) %{JONAS_ROOT}/clients

%attr(755,root,root) %{INIT_D_DIR}/%{PKG}

%pre
# **************************************************************************
#                                                        (pre install) %%pre
# **************************************************************************

#Logs files initialization for Pre Installation
[ ! -d `dirname %{LOG}` ] && mkdir -p `dirname %{LOG}`
echo -e "\n\n***************************************************" >>%{LOG}
echo -e "  Installation %{PKG} \n" >>%{LOG}

# JOnAS Root is needed for 'useradd'
mkdir -p %{JONAS_ROOT}

echo -e "Adding group %{GROUP} ..." >>%{LOG}
/usr/sbin/groupadd -r %{GROUP} 2>>%{LOG}
echo -e "Adding user %{USER} ..." >>%{LOG}
/usr/sbin/useradd -c JOnAS -d %{JONAS_ROOT} -g %{GROUP} %{USER} 2>>%{LOG}

%post
# **************************************************************************
#                                                      (post install) %%post
# **************************************************************************
chown %{USER}:%{GROUP} %{JONAS_ROOT}

# Register the jonas service
/sbin/chkconfig --add %{PKG}

%preun
# **************************************************************************
#                                                    (pre uninstall) %%preun
# **************************************************************************

####Logs files initialization for uninstallation
[ ! -d `dirname %{LOG}` ] && mkdir -p `dirname %{LOG}`
echo -e "\n\n***************************************************" >>%{LOG}
echo -e "  UnInstallation  %{PKG},  \n" >>%{LOG}
echo -e "\tPreUnInstallation" >>%{LOG}
echo -e "\t------------------" >>%{LOG}

# Actions in all cases
# Stop default JONAS if running
# WARNING : This will NOT stop other JOnAS instances !!!
/etc/init.d/%{PKG} stop -jb %{JONAS_ROOT}

# But the following test include all others JOnAS instances launched with a JONAS_BASE
if [ -n "`ps -ef | grep \"jonas.root=%{JONAS_ROOT}\" | egrep -v grep`" ]; then
   echo -e "Some other instances of JOnAS are running." >>%{LOG}
   echo -e "Please stop them before removing/updating %{PKG}-%{VERSION}-%{RPM_VERSION} RPM." >>%{LOG}
# FIXME : Uncomment this for official realease
   exit 1
fi

# Del jonas service
/sbin/chkconfig --del %{PKG}

%postun
# **************************************************************************
#                                                  (post uninstall) %%postun
# **************************************************************************

# Actions in update and total remove
# (postrun call with $1=0 if package not in RPM base )
# (postrun call with $1=1 if package in RPM base )

if [ $1 -eq 0 ]; then
  # Delete

  # Removing product user
  echo -e "Removing user %{USER} ..." >>%{LOG}
  userdel %{USER} 2>>%{LOG}

  JONAS_GRP=`cat /etc/group | grep %{GROUP} | wc -l`
  if [ $JONAS_GRP -eq 1 ]; then
    # Removing product group
    echo -e "Removing group %{GROUP} ..." >>%{LOG}
    groupdel %{GROUP} 2>>%{LOG}
  fi

fi

#%%clean
# **************************************************************************
#                                                            (clean) %%clean
# **************************************************************************
if [ "%{buildroot}" != "/" ]; then
	rm -rf %{buildroot}
fi

%changelog
# **************************************************************************
#                                                                %%changelog
# **************************************************************************
* Wed Aug 08 2007 Bull
+ Moving to JOnAS 5.0 M1
* Tue Nov 21 2006 Bull
+ Moving to JOnAS 4.8.3
+ Goes to OpenSource
+ Remove references to jonasctl, env.sh scripts : they're part of the official JOnAS distribution.
* Tue Mar 28 2006 Bull
+ Create needed directory at install time
* Wed Jan 11 2006 BT
+ Moving to JOnAS 4.6.6
* Mon Dec 05 2005 BT
+ Moving to JOnAS 4.6.3
+ Generic RPM for JOnAS
+ Use certified JOnAS packaging from ObjectWeb
+ Spec file clean-up
+ Added createjb, jonasctl (and env.*.sh), functions scripts
+ Multi-version support
* Fri Oct 07 2005 BT
+ Moving to JOnAS 4.5.3
* Wed Jun 1 2005 APS
+ creation of first Platon package for JOnAS 4.3.5
* Wed May 18 2005 APS
+ correction of parameter -Duser_dir of JAVA_OPTS in setEnv_jonas.sh : was set constant on JONAS_ROOT, it become variable, depending of JONAS_BASE
+ logrotate doesn't restart jonas at 4:00 AM any more
* Fri Feb 11 2005 APS
+ add of option for system optimization in sysctl.conf :
+ net.ipv4.tcp_syn_retries = 1
+ Defines how many times to try to send an initial SYN packet to a remote host before giving up and returns an error.
+ Must be below 255. This is only the timeout for outgoing connections; for incoming connections the number of retransmits
+ is defined by tcp_retries1.
* Fri Jan 14 2005 APS
+ customizing JOnAS 4.1.4 for RHEL 3.0 Platon
